package com.sillycycle.bagleyd.threed;

/*
 * @(#)ThreedInterface.java
 *
 * Copyright 1994 - 2018  David A. Bagley, bagleyd AT verizon.net
 *
 * All rights reserved.
 *
 * Permission to use, copy, modify, and distribute this software and
 * its documentation for any purpose and without fee is hereby granted,
 * provided that the above copyright notice appear in all copies and
 * that both that copyright notice and this permission notice appear in
 * supporting documentation, and that the name of the author not be
 * used in advertising or publicity pertaining to distribution of the
 * software without specific, written prior permission.
 *
 * This program is distributed in the hope that it will be "useful",
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 */

/**
 * The <code>ThreedInterface</code> class contains most of the
 * constants used by the <code>ThreedFrame</code> class.
 *
 * @author	David A. Bagley
 * @author	bagleyd AT verizon.net
 * @author	https://www.sillycycle.com/threed.html
 */

public class ThreedInterface {
	static final String XML_FILE = "threed.xml";

	static final int MINDISTANCE = -100;
	static final int MAX_DISTANCE = 100;
	static final int MIN_DEPTH = -50;
	static final int MAX_DEPTH = 150;
	static final int NUM_DEGREES = 360;
	static final int MIN_DEGREES = 0;
	static final int MAX_DEGREES = (NUM_DEGREES - 1);
	static final int ST_ANGLE = (NUM_DEGREES >> 1);
	static final int RT_ANGLE = (NUM_DEGREES >> 2);
	static final int ACTION_HIDE = 102;
	static final int ACTION_SET = 103;
	static final int ACTION_SURFACE = 104;
	static final int ACTION_OBJECT = 105;
	static final int ACTION_SPEED = 202;
	static final int ACTION_SLOW = 203;
	static final int ACTION_SOUND = 204;

	static final int TETRAHEDRON = 0;
	static final int HEXAHEDRON = 1;
	static final int OCTAHEDRON = 2;
	static final int DODECAHEDRON = 3;
	static final int ICOSAHEDRON = 4;
	static final int RHOMBIC_DODECAHEDRON = 5;
	static final int RHOMBIC_TRIACONTAHEDRON = 6;
	static final int TRUNCATED_OCTAHEDRON = 7;
	static final int IRREGULAR_DODECAHEDRON = 8;
	static final int TETRADECAHEDRON = 9;
	static final int STELLA_OCTANGULA = 10;
	static final int GREAT_DODECAHEDRON = 11;
	static final int SMALL_STELLATED_DODECAHEDRON = 12;
	static final int GREAT_STELLATED_DODECAHEDRON = 13;
	static final int GREAT_ICOSAHEDRON = 14;
	static final int PYRAMID = 15;
	static final int BOXES = 16;
	static final int F16 = 17;
	//static final int MAXOBJECTS = 18;

	static final String TITLE = "Threed";
	public enum Icons {X16, X22, X24, X32, X48, X64}
	static final String[] ICONS = {"icons/16x16/threed.png",
		"icons/22x22/threed.png",
		"icons/24x24/threed.png",
		"icons/32x32/threed.png",
		"icons/48x48/threed.png",
		"icons/64x64/threed.png"};

	static final String[] objectStrings = {
		"Tetrahedron",
		"Hexahedron", "Octahedron",
		"Dodecahedron", "Icosahedron",
		"Rhombic_Dodecahedron", "Rhombic_Triacontahedron",
		"Truncated Octahedron", "Irregular_Dodecahedron",
		"Tetradecahedron", "Stella_Octangula",
		"Great_Dodecahedron", "Small_Stellated_Dodecahedron",
		"Great_Stellated_Dodecahedron", "Great_Icosahedron",
		"Cuboctahedron", "Square_Antiprism", "Pyramid",
		"Cubes", "F16"};
	static String objectName(String string) {
		return string.replaceAll("_", " ");
	}
}
