package com.sillycycle.bagleyd.threed;

/*
 * @(#)ThreedSurface.java
 *
 * Copyright 2005 - 2014  David A. Bagley, bagleyd AT verizon.net
 *
 * All rights reserved.
 *
 * Permission to use, copy, modify, and distribute this software and
 * its documentation for any purpose and without fee is hereby granted,
 * provided that the above copyright notice appear in all copies and
 * that both that copyright notice and this permission notice appear in
 * supporting documentation, and that the name of the author not be
 * used in advertising or publicity pertaining to distribution of the
 * software without specific, written prior permission.
 *
 * This program is distributed in the hope that it will be "useful",
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 */

/**
 * The <code>ThreedSurface</code> class handles the surfaces to be
 * used for the <code>ThreedFrame</code> class.
 *
 * @author	David A. Bagley
 * @author	bagleyd AT verizon.net
 * @author	https://www.sillycycle.com/threed.html
 */

public class ThreedSurface {
	int         numVertices; /* number of vertices in surface plane */
	int         mapIndex; /* maps surface to first vertex */
	int         color;
	//int         shade;
	//int         shading;
	int         visible;
	//boolean     twoSided;
	boolean     clipped;
	//boolean     active;
	//double      normalLength;
	double      averageDepth;
	int         depthIndex; /* links surfaces, old use obscure */

	public ThreedSurface(int numVertices, int mapIndex,
			int color, /*int shade, int shading,*/ int visible,
			/*boolean twoSided,*/ boolean clipped,
			/*boolean active, double normalLength,*/
			double averageDepth, int depthIndex) {
		this.numVertices = numVertices;
		this.mapIndex = mapIndex;
		this.color = color;
		//this.shade = shade;
		//this.shading = shading;
		this.visible = visible;
		//this.twoSided = twoSided;
		this.clipped = clipped;
		//this.active = active;
		//this.normalLength = normalLength;
		this.averageDepth = averageDepth;
		this.depthIndex = depthIndex;
	}

	public ThreedSurface(int numVertices) {
		this.numVertices = numVertices;
		this.mapIndex = 0;
		this.color = 0;
		//this.shade = 0;
		//this.shading = 0;
		this.visible = 0;
		//this.twoSided = false;
		this.clipped = false;
		//this.active = true;
		//this.normalLength = 0.0;
		this.averageDepth = 0.0;
		this.depthIndex = 0;
	}

	public ThreedSurface(int mapIndex, int depthIndex, int color) {
		this.numVertices = 0; // will be filled in later
		this.mapIndex = mapIndex;
		this.color = color;
		//this.shade = 0;
		//this.shading = 0;
		this.visible = 0;
		//this.twoSided = false;
		this.clipped = false;
		//this.active = true;
		//this.normalLength = 0.0;
		this.averageDepth = 0.0;
		this.depthIndex = depthIndex;
	}

	public double averageDepth() {
		return this.averageDepth;
	}
}
